diff --git a/game/client/src/main/java/net/minecraft/client/gui/popup/ListComponent.java b/game/client/src/main/java/net/minecraft/client/gui/popup/ListComponent.java
index 1a4d1c1ec..1367f34a7 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/popup/ListComponent.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/popup/ListComponent.java
@@ -1,12 +1,13 @@
 package net.minecraft.client.gui.popup;
 
 import net.minecraft.client.render.Scissor;
-import net.minecraft.client.render.tessellator.Tessellator;
+import net.minecraft.client.render.renderer.GLRenderer;
+import net.minecraft.client.render.renderer.Shaders;
+import net.minecraft.client.render.tessellator.TessellatorGeneral;
 import net.minecraft.core.sound.SoundCategory;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
 import org.lwjgl.input.Mouse;
-import org.lwjgl.opengl.GL11;
 
 import net.minecraft.client.Minecraft;
 import net.minecraft.client.gui.ButtonElement;
@@ -100,13 +101,13 @@ public class ListComponent
             if (wheel != 0.0f)
                 this.scroll(wheel / -12.0f);
         }
-
-        GL11.glDisable(GL11.GL_TEXTURE_2D);
+        GLRenderer.pushFrame();
+        GLRenderer.setShader(Shaders.COLOR);
         this.drawBackground(x, y);
         this.drawScrollbar(x, y, mouseY);
 
         Scissor.enable(x + 1, y + 1, this.getWidth() - 2, this.getHeight() - 2);
-        GL11.glEnable(GL11.GL_TEXTURE_2D);
+        GLRenderer.popFrame();
 
         // Draw buttons
         for (int i = 0; i < this.buttons.length; i++) {
@@ -200,16 +201,16 @@ public class ListComponent
     }
 
     private void drawBackground(final int x, final int y) {
-        final @NotNull Tessellator tessellator = Tessellator.instance;
+        final @NotNull TessellatorGeneral tessellator = GLRenderer.getTessellator();
         tessellator.startDrawingQuads();
-        tessellator.setColorOpaque_I(0xA0A0A0);
+        tessellator.setColorOpaque1i(0xA0A0A0);
         tessellator.addVertex(x, y + this.height, 0.0D);
         tessellator.addVertex(x + this.getWidth(), y + this.height, 0.0D);
         tessellator.addVertex(x + this.getWidth(), y, 0.0D);
         tessellator.addVertex(x, y, 0.0D);
         tessellator.draw();
         tessellator.startDrawingQuads();
-        tessellator.setColorOpaque_I(0x000000);
+        tessellator.setColorOpaque1i(0x000000);
         tessellator.addVertex(x + 1, y + this.height - 1, 0.0D);
         tessellator.addVertex(x + this.getWidth() - 1, y + this.height - 1, 0.0D);
         tessellator.addVertex(x + this.getWidth() - 1, y + 1, 0.0D);
@@ -238,12 +239,12 @@ public class ListComponent
         this.scrollbarY = y + 1 + (int) (this.scrollAmount * scrollbarDelta);
         this.scrollbarX = x + this.getWidth() - 1 - 6;
 
-        final Tessellator t = Tessellator.instance;
+        final TessellatorGeneral t = GLRenderer.getTessellator();
 
         t.startDrawingQuads();
-        t.setColorRGBA_I(0x808080, 255);
+        t.setColor2i(0x808080, 255);
         t.drawRectangle(this.scrollbarX, this.scrollbarY, 6, this.scrollbarHeight);
-        t.setColorRGBA_I(0xc0c0c0, 255);
+        t.setColor2i(0xc0c0c0, 255);
         t.drawRectangle(this.scrollbarX, this.scrollbarY, 5, this.scrollbarHeight - 1);
         t.draw();
 
diff --git a/game/client/src/main/java/net/minecraft/client/gui/popup/MessageBoxComponent.java b/game/client/src/main/java/net/minecraft/client/gui/popup/MessageBoxComponent.java
index 22eba8002..1766d8fca 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/popup/MessageBoxComponent.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/popup/MessageBoxComponent.java
@@ -2,12 +2,13 @@ package net.minecraft.client.gui.popup;
 
 import net.minecraft.client.Minecraft;
 import net.minecraft.client.render.Scissor;
-import net.minecraft.client.render.tessellator.Tessellator;
+import net.minecraft.client.render.renderer.GLRenderer;
+import net.minecraft.client.render.renderer.Shaders;
+import net.minecraft.client.render.tessellator.TessellatorGeneral;
 import net.minecraft.core.net.command.TextFormatting;
 import net.minecraft.core.util.helper.MathHelper;
 import org.jetbrains.annotations.NotNull;
 import org.lwjgl.input.Mouse;
-import org.lwjgl.opengl.GL11;
 
 import java.util.ArrayList;
 import java.util.Arrays;
@@ -110,16 +111,17 @@ public class MessageBoxComponent
                 this.scroll(wheel / -12.0f);
         }
 
-        GL11.glDisable(GL11.GL_TEXTURE_2D);
+        GLRenderer.pushFrame();
+        GLRenderer.setShader(Shaders.COLOR);
         this.drawBackground(x, y);
         this.drawScrollbar(x, y, mouseX, mouseY);
 
         Scissor.enable(x + 1, y + 1, this.getWidth() - 2, this.getHeight() - 2);
-        GL11.glEnable(GL11.GL_TEXTURE_2D);
+        GLRenderer.popFrame();
 
         // Draw lines
         for (int i = 0; i < this.lines.size(); i++) {
-            this.minecraft.font.render(Tessellator.instance, this.lines.get(i), x + 4, (y + 4) + (i * 12) - this.getScrollPixels()).setShadow().call();
+            this.minecraft.font.render(this.lines.get(i), x + 4, (y + 4) + (i * 12) - this.getScrollPixels()).setShadow().call();
         }
 
         Scissor.disable();
@@ -159,16 +161,16 @@ public class MessageBoxComponent
     }
 
     private void drawBackground(final int x, final int y) {
-        final Tessellator tessellator = Tessellator.instance;
+        final TessellatorGeneral tessellator = GLRenderer.getTessellator();
         tessellator.startDrawingQuads();
-        tessellator.setColorOpaque_I(0xA0A0A0);
+        tessellator.setColorOpaque1i(0xA0A0A0);
         tessellator.addVertex(x, y + this.height, 0.0D);
         tessellator.addVertex(x + this.getWidth(), y + this.height, 0.0D);
         tessellator.addVertex(x + this.getWidth(), y, 0.0D);
         tessellator.addVertex(x, y, 0.0D);
         tessellator.draw();
         tessellator.startDrawingQuads();
-        tessellator.setColorOpaque_I(0x000000);
+        tessellator.setColorOpaque1i(0x000000);
         tessellator.addVertex(x + 1, y + this.height - 1, 0.0D);
         tessellator.addVertex(x + this.getWidth() - 1, y + this.height - 1, 0.0D);
         tessellator.addVertex(x + this.getWidth() - 1, y + 1, 0.0D);
@@ -192,12 +194,12 @@ public class MessageBoxComponent
         this.scrollbarY = y + 1 + (int) (this.scrollAmount * scrollbarDelta);
         this.scrollbarX = x + this.getWidth() - 1 - 6;
 
-        final @NotNull Tessellator t = Tessellator.instance;
+        final @NotNull TessellatorGeneral t = GLRenderer.getTessellator();
 
         t.startDrawingQuads();
-        t.setColorRGBA_I(0x808080, 255);
+        t.setColor2i(0x808080, 255);
         t.drawRectangle(this.scrollbarX, this.scrollbarY, 6, this.scrollbarHeight);
-        t.setColorRGBA_I(0xc0c0c0, 255);
+        t.setColor2i(0xc0c0c0, 255);
         t.drawRectangle(this.scrollbarX, this.scrollbarY, 5, this.scrollbarHeight - 1);
         t.draw();
 
diff --git a/game/client/src/main/java/net/minecraft/client/gui/popup/PopupScreen.java b/game/client/src/main/java/net/minecraft/client/gui/popup/PopupScreen.java
index c6af3e112..d6ba8acd5 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/popup/PopupScreen.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/popup/PopupScreen.java
@@ -2,11 +2,11 @@ package net.minecraft.client.gui.popup;
 
 import it.unimi.dsi.fastutil.ints.IntIntPair;
 import net.minecraft.client.gui.Screen;
-import net.minecraft.client.render.tessellator.Tessellator;
+import net.minecraft.client.render.renderer.GLRenderer;
+import net.minecraft.client.render.tessellator.TessellatorGeneral;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
 import org.lwjgl.input.Keyboard;
-import org.lwjgl.opengl.GL11;
 
 import java.util.*;
 
@@ -165,10 +165,10 @@ public final class PopupScreen
         final int popupX = this.width / 2 - this.popupWidth / 2;
         final int popupY = this.height / 2 - this.popupHeight / 2;
 
-        GL11.glDisable(GL11.GL_LIGHTING);
-        GL11.glDisable(GL11.GL_FOG);
-        final @NotNull Tessellator tessellator = Tessellator.instance;
-        GL11.glColor4f(1.0F, 1.0F, 1.0F, 1.0F);
+        GLRenderer.globalSetLightEnabled(false);
+//        GL11.glDisable(GL11.GL_FOG);
+        final @NotNull TessellatorGeneral tessellator = GLRenderer.getTessellator();
+        GLRenderer.setColor4f(1.0F, 1.0F, 1.0F, 1.0F);
 
         if (this.backgroundColor == null) {
             final int color = this.mc.gameSettings.guiBackgroundColor.value.getARGB();
@@ -179,11 +179,10 @@ public final class PopupScreen
 
         this.drawRectWidthHeight(popupX - 1, popupY - 1, this.popupWidth + 2, this.popupHeight + 2, 0xFFA0A0A0);
 
-        GL11.glEnable(GL11.GL_TEXTURE_2D);
         final float f = 32F;
         tessellator.startDrawingQuads();
         this.mc.textureManager.loadTexture("/assets/minecraft/textures/gui/background.png").bind();
-        tessellator.setColorOpaque_I(0x404040);
+        tessellator.setColorOpaque1i(0x404040);
         tessellator.addVertexWithUV(popupX, popupY + this.popupHeight, 0.0D, 0.0D, (float) this.popupHeight / f);
         tessellator.addVertexWithUV(popupX + this.popupWidth, popupY + this.popupHeight, 0.0D, (float) this.popupWidth / f, (float) this.popupHeight / f);
         tessellator.addVertexWithUV(popupX + this.popupWidth, popupY, 0.0D, (float) this.popupWidth / f, 0);
